<template>
	<component :is="data.element" v-if="data.element === 'nuxt-link'" v-bind="data.props" @click.native="click">
		<div :class="$style.text">
			<slot />
		</div>
	</component>
	<component :is="data.element" v-else v-bind="data.props" @click="click">
		<div v-if="isWorkingNormalized" :class="$style.spinnerWrapper" :style="{ color: data.spinnerColor }">
			<BaseSpinner />
		</div>
		<div :class="$style.text">
			<template v-if="isAddToCart">{{ addToCartText }}</template>
			<slot v-else />
		</div>
	</component>
</template>

<script>
import smartLinkButton from '~/mixins/smart-link-button';

const ctaVariants = {
	Outline: '',
	Green: 'secondary',
	Black: 'primary',
	White: 'tertiary',
};

export default {
	mixins: [smartLinkButton],

	props: {
		size: {
			type: String,
			default: '',
		},

		appearance: {
			type: String,
			default: '',
		},

		forceColor: {
			type: Boolean,
			default: false,
		},

		customAppearance: {
			type: Object,
			default: null,
		},
	},

	computed: {
		data() {
			let { appearanceNormalized: appearance } = this;
			const { dataShared } = this;
			const { size, $style, isWorkingNormalized } = this;
			const props = {};
			const additional = {};

			if (this.isAddToCart) {
				if (!this.forceColor) {
					appearance = 'primary';
				}
			}

			if (appearance === 'custom') {
				const { background = '#000', backgroundHover, text = '#fff' } = this.customAppearance || {};
				props.style = {
					backgroundColor: background,
					borderColor: text,
					color: isWorkingNormalized ? 'transparent' : text,
					'--color-hover': backgroundHover || background,
				};
				additional.spinnerColor = text;
			}

			props.class = [$style.button, $style[size], $style[appearance], { [$style.isWorking]: isWorkingNormalized }];

			return {
				...dataShared,
				...additional,
				props: {
					...dataShared.props,
					...props,
				},
			};
		},

		appearanceNormalized() {
			const { appearance } = this;
			if (ctaVariants[appearance] !== undefined) return ctaVariants[appearance];
			return appearance;
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

.button {
	position: relative;
	display: inline-block;
	min-width: 13.65rem;
	color: inherit;
	text-align: center;
	border: 2px solid;
	border-radius: 1.8rem;
	transition: all 0.25s ease-in-out;

	@include use-text-style('type-400');

	&.isWorking {
		transition: none;
	}
}

.text {
	.isWorking & {
		color: transparent;
	}
}

.medium {
	padding: 0.9rem 3rem 0.8rem;
}

.large {
	padding: 1.3rem 5rem;
	font-size: 2rem;
	border-radius: 2.8rem;
}

.primary {
	color: color('white');
	background-color: color('button-primary');
	border-color: color('button-primary');

	&:hover,
	&:focus {
		background-color: color('button-primary-hover');
		border-color: color('button-primary-hover');
	}

	&:disabled {
		color: color('primary-200');
		background-color: color('button-disabled');
		border-color: color('button-disabled');
	}
}

.secondary {
	color: color('text');
	background-color: color('button-secondary');
	border-color: color('button-secondary');

	&:hover,
	&:focus {
		background-color: color('button-secondary-hover');
		border-color: color('button-secondary-hover');
	}

	&:disabled {
		color: color('primary-200');
		background-color: color('button-disabled');
		border-color: color('button-disabled');
	}
}

.tertiary {
	color: color('black');
	background-color: color('button-tertiary');
	border-color: color('button-tertiary');

	&:hover,
	&:focus {
		background-color: color('button-tertiary-hover');
		border-color: color('button-tertiary-hover');
	}

	&:disabled {
		color: color('primary-200');
		background-color: color('button-disabled');
		border-color: color('button-disabled');
	}
}

.custom {
	&:hover,
	&:focus {
		background-color: var(--color-hover) !important;
	}
}

.spinnerWrapper {
	position: absolute;
	top: 0;
	left: 0;
	display: flex;
	align-items: center;
	justify-content: center;
	width: 100%;
	height: 100%;

	.primary &,
	.secondary & {
		color: color('primary-200');
	}
}
</style>
